Category: Issues workflow Estimated time: 0.00 hour

Target version: 3.3.0   

Resolution: Fixed   

Description

What about adding  rbac to trackers? One of the most requested feature i'm asked (currently, on trac) is to expose the

interface to the customers, having each customer a partial view of the issues (only the ones he issue, for instance).

Maybe things get too complicated and the whole thing may be handled differently..

The simplest workaround could be to manage a separate project for each customer, but this way the development team will

loose the global view of the project.

I can analyze the issue (and maybe implement it) if it is a sensible one.

Regards,

Alessio

Related issues:

Related to Redmine - Feature #973: Assign different status sets and workflows... New 2008-04-02

Related to Redmine - Feature #1462: Access control to trackers by user roles/... Closed 2008-06-16

Related to Redmine - Feature #7839: Limit trackers for new issue to certain r... Closed 2011-03-11

Related to Redmine - Feature #8570: Extension of the tracker-role relation Closed 2011-06-09

Related to Redmine - Feature #3077: Customer Feedback System New 2009-03-30

Related to Redmine - Feature #8488: Create an 'Involve' mechanism to private ... New

Related to Redmine - Defect #23969: Edit/delete links displayed on issue even... Closed

Related to Redmine - Defect #30121: Projects API should not return invisible ... Closed

Has duplicate Redmine - Feature #3726: Trackers per Role Closed 2009-08-10

Has duplicate Redmine - Feature #2791: Allow trackers to be visible by specif... Closed 2009-02-20

Has duplicate Redmine - Feature #2240: Ability to constrain tracker by role Closed 2008-11-27

Has duplicate Redmine - Feature #16309: Add a concept of role-based permissio... Closed

Precedes Redmine - Defect #34570: Misleading workflow/permission issue New

Precedes Redmine - Defect #34284: In Role edit view the per tracker table onl... New

Associated revisions

Revision 15465 - 2016-06-05 13:50 - Jean-Philippe Lang

Adds issue visibility by role/tracker (#285).

Revision 15466 - 2016-06-05 15:45 - Jean-Philippe Lang

Adds permission to edit and delete issues by role/tracker (#285).

Revision 15478 - 2016-06-06 11:41 - Jean-Philippe Lang

Merged 15430, 15464 to 15469, 15475, 15476 (#285, #7839).

Revision 15540 - 2016-06-18 08:42 - Jean-Philippe Lang

Limits the tracker list in filters and issue counts (#285).

Revision 15542 - 2016-06-18 08:46 - Jean-Philippe Lang

Merged r15540 (#285).
History

#1 - 2007-03-16 13:13 - Jeffrey Jones

This would be a huge advantage and I agree that it is a pretty

important feature for most companies (and is pretty standard

on bugtrackers such as Mantis).

I would envision at a minimum a hardcoded "Internal"

/ "External" grouping. Any issue raised by a member

of the "Internal" group would only be visible to them

unless explicitely changed to "public" viewing.

A more advanced way would be to have configurable groups and

a  matrix of who can view issues raised by members of each group

(rather like the current workflow setup).

Group assignment can be done when members are added to the project.

#2 - 2007-03-27 03:19 - Thomas Lecavelier

I share the opinion of Jeffrey and Alessio.

I think the better way to handle this feature is to keep it simple:

redmine should stay a powerful management tool with each of its

killer^Wbig feature ready to use out-of-the-box.

Of course, the matrix idea that exposed Jeffrey is the cleaner

way, but it means that the redmine administrator have a real

work upstream to prepare the matrix and the different rights

for each group and users (which means the admin has already an

headache because of grouping users...).

The "first level" of user differentiation should be

a simple field in the user creation form (as Jeffrey said):

Internal/External.

Based upon this, a issue created by an "external" user

is always visible worldwide, but an "internal" user

has one more field in its issue form which allow him to set the

visibility of his issue (the default scope should be configured

in the project page by the administrator).

And yes, the matrix should exist too, but should be an "advanced

feature" for big projects where the admin is not the first

developer who want to handle correctly his issues.

#3 - 2007-07-31 16:19 - Chris Leonard

This would be a great addition to redMine. As it is today (v

0.5.1) our I/T staff is using it to manage the development of

several of our web and software projects (which, BTW, redMine

is the best tool I've used for this). Our marketing department

has seen the tool and is eager to use it as well. I haven't yet

allowed them access because any marketing manager will have complete

access to our current projects. I have considered installing

a 2nd instance of rM for other teams within the company, but

that opens other issues (multiple accounts for execs, etc).

The simplest way that I know of would be to add groups meta data

to users and projects, and provide an interface to associate

them. This would be somewhat similar to the way the Permissions

report page works.

Thanks, and keep up the good work.

Chris

#4 - 2007-08-01 04:39 - Thomas Lecavelier

This could be a prioritary feature, since there's maybe the last

thing that prevent a mass adoption of redmine by my client.

A non-technical view of issues will be a great help for manager,

with some statistics to please the most of managers.

#5 - 2007-08-01 16:47 - Chris Leonard
I spent a little more time researching this and thinking through

it.

A new role would be required for this to work well, above that

of manager. I'll call this new role Exec, but it could be admin

or root or whatever. Exec would need the ability to create groups

and manage which projects are available within groups.

I picture projects being able to be shared amongst groups, similar

to the way there are many users and many projects, and they can

cross over between the two.

I think my initial suggestion of a page just like the permissions

report page would work. It could be a matrix that listed the

available groups on one axis and the projects on the other axis.

Or, a groups tab similar to the Projects tab, in which you can

add & remove projects.

This would require at least:

-a group entry in the database

-a 'groups' folder within app/views with associated rhtml files

I'm willing to fully document this if its helpful. Not trying

to be domineering or controling, but if it would help to have

a description of how to include this functionality I'm willing

to pitch in. I'm also willing to help with coding it, but know

in advance that I'll be slow (still learning ruby).

Thanks,

Chris

#6 - 2008-05-12 18:27 - gabriel scolan

What a nice feature it will be !

Of course the admin would have more work to precisely tune the roles / permissions for fields for each user/group.

I currently have on my team developper and tester, who share most of the fields, but some fields are very specific for one group and the other groups

should not be upset why those fields. As a manager, I'd like however to see all fields to check the coherency and understand / follow each group's

work.

To complete the dream, may be it could be interesting to unable/disable editing of fields depending on the status of the issue. This would prevent

misunderstanding across teams just because a decision on a solution was changed while the implementation and/or tests are on their way.

A matrix having the fields name in row and the statuses in column, with a selector, as proposed above, being the group. The value in the boxes would

then be :  [viewable|editable|hidden]

here is an example (not sure the assignment are correct ..)

group : Developer

fields/status      open     assigned    resolved   closed

summary            viewable viewable    viewable   viewable

priority           viewable viewable    viewable   viewable

description        editable viewable    viewable   viewable

decision           hidden   viewable    viewable   viewable

tester_assignee    hidden   hidden      hidden     hidden

regards

gabriel

#7 - 2008-06-04 12:58 - Oyku Gencay

Hi folks,

This was the first thing that popped up during my initial review of redmine. I've implemented this functionality. Even before reading Gabriel's post, I've

started doing that the way he thought.

So the code lies on my computer. What is the best way to share it?

Thanks.

#8 - 2008-06-06 16:53 - gabriel scolan

That will be great to have this in version 0.8 ! I'm eager to see it as a feature of Redmine !

#9 - 2008-09-02 08:19 - gabriel scolan
Hi Oyku,

Did you find your way to share your code ? I really like to see this. May be you could attached it to this ticket, identifying the baseline (version 0.7.1 for

example) with quick instructions for installing it.

many thanks

gabriel

#10 - 2008-11-26 21:43 - Guilherme Schneider

I'm interested in this too.

#11 - 2009-12-15 23:10 - Mélanie Gault

is there any more informations about this feature ?

I am interested too...

#12 - 2010-03-10 15:57 - Dario Laera

+1 for me

#13 - 2011-06-09 10:35 - Etienne Massip

- Category set to Issues workflow

#14 - 2011-08-17 11:01 - Julien Breux

Up, up, up and up :-)

Please, this is the only missing features to allow customers to enter bugs properly.

#15 - 2011-08-19 16:41 - Ross Hendrickson

Same here...could really use this to allow for people outside development to create suggestions and bugs, but keep them from being able to create

features.

#16 - 2011-10-19 11:32 - James Ang

+1

#17 - 2012-06-07 10:34 - Mariano crivello

+10 :D

#18 - 2012-09-20 09:14 - Sam Warns

+1

#19 - 2012-09-24 15:50 - Florent Fievez

+1

#20 - 2012-10-18 11:26 - Anthony HERBÉ

- Assignee set to Jean-Philippe Lang

+1

"The simplest workaround could be to manage a separate project for each customer, but this way the development team will loose the global view of

the project."

I confirm that this workaround is not acceptable because of the loss of global view of the project concernend and the duplication of it.

#21 - 2013-03-18 20:51 - Dipan Mehta

We have had a similar situation where we didn't wanted field engineers to file "Bug" but only "Incident report".

Unfortunately currently Redmine doesn't support this feature. However there is a plugin called Redmine Tracker Control which allows that specific

roles (including anonymous) to create issues of specific type trackers only!

Though, I strongly believe this should be a core feature of Redmine.

#22 - 2013-03-18 20:52 - Dipan Mehta

The issue #3077 will be solved by this one.
#23 - 2013-07-25 19:13 - François Pouilloux

Ross Hendrickson wrote:

Same here...could really use this to allow for people outside development to create suggestions and bugs, but keep them from being able to

create features.

 +1

Same need here, reporters can create bugs but features are in the hands of the development team.

#24 - 2013-07-27 13:09 - Terence Mill

+1

#25 - 2013-08-30 11:10 - Anthony HERBÉ

Dipan Mehta wrote:

However there is a plugin called Redmine Tracker Control which allows that specific roles (including anonymous) to create issues of specific type

trackers only!

 But this plugin only give restrictions on creation but not on view issues of tracker types.

#26 - 2013-08-30 13:51 - Daniel Felix

Maybe I missed something, but this is already possible, doesn't it? You can define a role which enables each user just to see his own issues.

Do you mean this feature with this request or something different?

#27 - 2013-09-05 19:43 - Ty You

Holy cow, this issue is #285 and over six years old, and we're still asking what the feature means?

It's been "plus-one'd" to death, what the heck has to happen to get it addressed?!?  Not having this feature is a major setback.

I gave the "Redmine Tracker Control" a shot but it crashed my 2.2.x installation.

#28 - 2013-09-05 23:33 - Ty You

...but I went to GitHub and pulled version 1.0.8 instead of the 1.0.5 listed here and it worked!  Nice, this should be made more obvious - thanks!

#29 - 2013-10-22 12:06 - Lázaro Hermoso

- File Issues Visibility.JPG added

+1

Definitely and improvement!

Maybe it could be implemented by adding more functionality in 'Issues visibility' within Roles and Permissions Administration Menu.

!Issues Visibility.JPG!

When selecting a Role you can select Issues Visibility between:

1. All issues

2. All non private issues

3. Issues created by or assigned to the user

4. In my opinion a solution could be to add here the functionality of selecting the trackers that each role can view

In #8488 it was achieved to let watchers view issues eventhough their permission was set to 'issues created by or assigned to the user'. This is

somehow a solution but it would be annoying to add users as watchers to every single issue.

I am sorry that I am not a developer and I cannot help with the code... :(

#30 - 2013-12-12 12:00 - David Marín Carreño

+1

Please add this functionality. We have a tracker that is meant for internal use, and some customers insist on adding issues to this tracker because its

name seems more convenient to them... And after that they keep on complaining about they can't change the status of these issues...

#31 - 2014-02-13 15:41 - Jack  Casas
+1 to request this

I installed Redmine 2.4.3.stable for the first time in my company yesterday. After one day of use, I only miss this issue!

We need our customers to only be able to open Support requests. Features and Bugs are only for internal use!

We can't use "Issues created by or assigned to the user" because the customers controller has to see all the active support requests!

We need selecting the trackers that each role can view. Thanks!!

UPDATE: I now have this feature thanks to the plugin http://www.redmine.org/plugins/redmine_track_control

The version that is working for my latest version 2.4.3 is:

https://github.com/jijeshmohan/redmine_track_control/zipball/redmine2

I still believe this should be included in the core pack.

#32 - 2014-03-18 03:23 - Sam He

+1

I do hope this permission control can be included in the core pack asap.

#33 - 2014-06-17 17:32 - Monica Kochofar

+1

It would certainly make the experience for our users a whole lot smoother.

#34 - 2014-07-17 00:50 - Toshi MARUYAMA

- Related to Feature #8488: Create an 'Involve' mechanism to private issues added

#35 - 2014-10-02 20:41 - Maxim Krušina

+1 ... I really hate t create separate projects for client support... (now I have to create just one more :). It would be really great to be able just add

tracker for client support, so it vill be visible to different roles, like:

Client support tracker:

Clients (group) - visible

Project Managers (group) - visible

Developers (group) - not visible

And our internal trackers (Features, Bugs)

Clients (group) - not visible

Project Managers (group) - visible

Developers (group) - visible

#36 - 2014-10-29 23:17 - Artem Tovbin

+1.

We need to get view access to Customer to some tracker.

#37 - 2015-02-19 22:15 - mike B

In our company we have many issues that are necessary to have other "non-members" of the project to be involved in an specific issue but it is not

necessary nor it is wanted for them to have full access to ALL of the issues in the project, only the ones they have been added as "watchers" to.

one workaround I tried was creating a group called "Watchers", adding ALL of the users to that group. I then set the permissions for that role to where

they cannot see issues in a project unless it is assigned to them. The group's permissions are as limited as possible.

Just adding a "Watched issues" option to the Issues Visibility list for the Roles/Permissions page would be awesome!

#38 - 2015-07-07 20:35 - Alex Petty

We should add the functionality given by plugin "Redmine Tracker Control" (which allows for specific roles to only be able to create issues of tracker

types for which the role has been given permission).

It would be great if this feature could be part of the Redmine 3.0.4 release since the "Redmine Tracker Control" plugin no longer works in 3.x

This would truly be a GREAT and VALUABLE feature for Redmine's overall flexibility in configuration, and would be hugely appreciate by many!!

#39 - 2015-07-09 16:47 - Ricard F
I think too it should be added nativelly!!

#40 - 2015-08-17 20:52 - Michal Kowalski

Yes please.

#41 - 2015-08-24 21:17 - Joe Zuber

We too have a need for this functionality. We don't want to move some users to a seperate project but we do want to restrict them to only creating bug

tickets. I would add to this request that the role based rights should also be tied to the project.

#42 - 2015-09-05 14:44 - Thorsten Jäger

In our case i want Profession-Service and Project-Managers in a Project - but only allow them to certain Trackers. They should not see other Trackers

like "Bugs" "Features" "Escalations" etc.

The other case is Business-Partners. It would be very important of course to NOT let them see/work on internal Trackers in the same Project as they

may contain internal Information.

In our case it also would be appreciated if i still could relate an issue (like "depends on").

Example: PJ-Mgr has R/W Access to Tracker "Task" but not other Trackers (like Bugs). It would be appreciated if the Developer-Role can have a

"BUG" (Tracker) and set the relation to an issue in the "Task" Tracker - so the PJ-Mgr sees a dependency to that Bug in his "Task"-issue - but would

not be able to move into that Bug-issue.

#43 - 2015-11-09 16:52 - Anton Titkov

Hello everyone!

Please check a plugin http://www.redmine.org/plugins/tracker_hider and share your thoughts. Thanks!

#44 - 2015-11-11 15:16 - Anton Titkov

Anton Titkov wrote:

Hello everyone!

Please check a plugin http://www.redmine.org/plugins/tracker_hider and share your thoughts. Thanks!

 Hello guys!

Has enybody tested the plugin?

It allows to hide issues under selected tracker for roles/users within a project. It solves the subject partly as i see.

It would be nice to get some feeback from you!

Thanks!

#45 - 2016-06-06 12:42 - Jean-Philippe Lang

- Status changed from New to Closed

- Target version set to 3.3.0

- Resolution set to Fixed

3.3.0 will support tracker based permissions for issue tracking. You will be able to limit the trackers for which a role is allowed to view, create, edit or

delete issues.

#46 - 2016-10-02 12:59 - Jean-Philippe Lang

- Related to Defect #23969: Edit/delete links displayed on issue even if project is closed added

#47 - 2017-05-08 21:27 - Shane Coronado

- File create_tickets_by_copy.jpg added

- File create_tickets_by_copy2.jpg added

- File create_tickets_by_copy3.jpg added

- File create_tickets_by_copy4.jpg added

Not sure if intended: We use the permission settings for our roles.  However, our Developer role is able to create an issue that the role does not have

permission to create.  This was done by Copying said issue and not changing the Tracker field.  By leaving the Tracker field blank, the user is able to

create an issue that bypasses the role's permissions.

#48 - 2017-06-06 21:37 - Toshi MARUYAMA

Shane Coronado wrote:
Not sure if intended:...

 FTR: #25791.

#49 - 2018-09-28 20:37 - Darwin Pou

How could I restrict access to a group of issues by user-role, tracker and state in workflow?

For example;

Role 2 can only view issues for workflow statuses: "Level 2" or "Level 3".

Role 3 can only view issues for workflow status: "Level 3".

Any: Could be viewed by "Role 1".

By now I have to limit readonly access to fields for specific status and role; but when I create a new status I have to modify all roles for that new

status.

#50 - 2018-12-08 01:12 - Go MAEDA

- Related to Defect #30121: Projects API should not return invisible trackers added

#51 - 2019-06-02 06:23 - Go MAEDA

- Has duplicate Feature #16309: Add a concept of role-based permission to trackers added

#52 - 2021-02-02 13:33 - Mischa The Evil

- Precedes Defect #34570: Misleading workflow/permission issue added

#53 - 2021-02-02 13:34 - Mischa The Evil

- Precedes Defect #34284: In Role edit view the per tracker table only shows up when "View Issues" permission is selected added

Files

Issues Visibility.JPG 28 KB 2013-10-22 Lázaro Hermoso

create_tickets_by_copy.jpg 29.7 KB 2017-05-08 Shane Coronado

create_tickets_by_copy2.jpg 24.6 KB 2017-05-08 Shane Coronado

create_tickets_by_copy3.jpg 20.2 KB 2017-05-08 Shane Coronado

create_tickets_by_copy4.jpg 30.4 KB 2017-05-08 Shane Coronado
